// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f middlewaretcps.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// MiddlewareTCPSpec defines the desired state of a MiddlewareTCP.
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "traefik.io",
    version = "v1alpha1",
    kind = "MiddlewareTCP",
    plural = "middlewaretcps"
)]
#[kube(namespaced)]
#[kube(derive = "Default")]
#[kube(derive = "PartialEq")]
pub struct MiddlewareTCPSpec {
    /// InFlightConn defines the InFlightConn middleware configuration.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "inFlightConn"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub in_flight_conn: Option<MiddlewareTCPInFlightConn>,
    /// IPAllowList defines the IPAllowList middleware configuration.
    /// This middleware accepts/refuses connections based on the client IP.
    /// More info: https://doc.traefik.io/traefik/v3.2/middlewares/tcp/ipallowlist/
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "ipAllowList"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ip_allow_list: Option<MiddlewareTCPIpAllowList>,
    /// IPWhiteList defines the IPWhiteList middleware configuration.
    /// This middleware accepts/refuses connections based on the client IP.
    /// Deprecated: please use IPAllowList instead.
    /// More info: https://doc.traefik.io/traefik/v3.2/middlewares/tcp/ipwhitelist/
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "ipWhiteList"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ip_white_list: Option<MiddlewareTCPIpWhiteList>,
}

/// InFlightConn defines the InFlightConn middleware configuration.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct MiddlewareTCPInFlightConn {
    /// Amount defines the maximum amount of allowed simultaneous connections.
    /// The middleware closes the connection if there are already amount connections opened.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub amount: Option<i64>,
}

/// IPAllowList defines the IPAllowList middleware configuration.
/// This middleware accepts/refuses connections based on the client IP.
/// More info: https://doc.traefik.io/traefik/v3.2/middlewares/tcp/ipallowlist/
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct MiddlewareTCPIpAllowList {
    /// SourceRange defines the allowed IPs (or ranges of allowed IPs by using CIDR notation).
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "sourceRange"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub source_range: Option<Vec<String>>,
}

/// IPWhiteList defines the IPWhiteList middleware configuration.
/// This middleware accepts/refuses connections based on the client IP.
/// Deprecated: please use IPAllowList instead.
/// More info: https://doc.traefik.io/traefik/v3.2/middlewares/tcp/ipwhitelist/
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct MiddlewareTCPIpWhiteList {
    /// SourceRange defines the allowed IPs (or ranges of allowed IPs by using CIDR notation).
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "sourceRange"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub source_range: Option<Vec<String>>,
}
